<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Task 29.60</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- font -->
    <link
      rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Lato"
    />
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css"
    />
  </head>

  <body onload="onPageLoading()">
    <div class="container">
      <h2 class="text-center">Danh sách người dùng đăng ký</h2>
      <table
        id="user-table"
        class="table table-bordered table-striped table-hover"
      >
        <thead>
          <tr>
            <th>Mã người dùng</th>
            <th>Firstname</th>
            <th>Lastname</th>
            <th>Country</th>
            <th>Subject</th>
            <th>Customer Type</th>
            <th>Register Status</th>
            <th>Action</th>
          </tr>
        </thead>
        <tbody></tbody>
      </table>
    </div>
    <script>
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gBASE_URL =
        "http://203.171.20.210:8080/devcamp-register-java-api/users";
      const gREQUEST_STATUS_OK = 200;
      const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

      const gEND_ROW_TABLE = -1;
      // Biến toàn cục định nghĩa chỉ số các cột tương ứng
      const gUSER_ID_COL = 0;
      const gFIRSTNAME_COL = 1;
      const gLASTNAME_COL = 2;
      const gCOUNTRY_COL = 3;
      const gSUBJECT_COL = 4;
      const gCUSTOMER_TYPE_COL = 5;
      const gREGISTER_STATUS_COL = 6;
      const gUSER_ACTION_COL = 7;
      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      //hàm xử lý sự kiện khi tải trang
      function onPageLoading() {
        // hiển thị dữ liệu lên table
        showDataOnTable();
      }

      // onBtnChiTietClick, ấn nút chi tiết
      function onBtnChiTietClick(paramDetailButton) {
        // thu thập dữ liệu
        var vId = paramDetailButton.dataset.id;
        var vFirstname = paramDetailButton.dataset.firstname;
        var vLastname = paramDetailButton.dataset.lastname;
        var vCountry = paramDetailButton.dataset.country;
        var vSubject = paramDetailButton.dataset.subject;

        console.log("id: " + vId);
        console.log("Firstname: " + vFirstname);
        console.log("Lastname: " + vLastname);
        console.log("Country: " + vCountry);
        console.log("Subject: " + vSubject);

        const vDETAIL_FORM_URL = "UserDetails.html";
        var vUrlSiteToOpen = vDETAIL_FORM_URL + "?" + "id=" + vId;
        window.location.href = vUrlSiteToOpen;
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      function showDataOnTable() {
        //B3: gọi api để lấy dữ liệu
        var vXHTMLRequest = new XMLHttpRequest();
        goiApi(vXHTMLRequest);

        vXHTMLRequest.onreadystatechange = function () {
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_OK
          ) {
            // console.log("responseText = " + vXHTMLRequest.responseText); //đây là responses text bạn có thể  phân tích
            var bUsersObj = JSON.parse(vXHTMLRequest.responseText);
            //B4: hiển thị dữ liệu
            hienThiDuLieu(bUsersObj);
          }
        };
      }

      //hàm gọi api để lấy list users
      function goiApi(paramXHTMLRequest) {
        paramXHTMLRequest.open("GET", gBASE_URL, true);
        paramXHTMLRequest.send();
      }

      //hàm hiển thị list user lên trang web
      function hienThiDuLieu(paramUsersObj) {
        var vTable = document.getElementById("user-table");
        var vTableBody = vTable.getElementsByTagName("tbody")[0];

        for (var bIndex = 0; bIndex < paramUsersObj.length; bIndex++) {
          var vUser = paramUsersObj[bIndex];
          // tạo dòng mới cho bảng và ghi vào các giá trị
          var vRow = vTableBody.insertRow(gEND_ROW_TABLE);

          var vCellUserId = vRow.insertCell(gUSER_ID_COL);
          var vCellFirstname = vRow.insertCell(gFIRSTNAME_COL);
          var vCellLastname = vRow.insertCell(gLASTNAME_COL);
          var vCellCountry = vRow.insertCell(gCOUNTRY_COL);
          var vCellSubject = vRow.insertCell(gSUBJECT_COL);
          var vCellCustomerType = vRow.insertCell(gCUSTOMER_TYPE_COL);
          var vCellRegisterStatus = vRow.insertCell(gREGISTER_STATUS_COL);
          var vCellUserAction = vRow.insertCell(gUSER_ACTION_COL);

          vCellUserId.innerHTML = vUser.id;
          vCellFirstname.innerHTML = vUser.firstname;
          vCellLastname.innerHTML = vUser.lastname;
          vCellCountry.innerHTML = vUser.country;
          vCellSubject.innerHTML = vUser.subject;
          vCellCustomerType.innerHTML = vUser.customerType;
          vCellRegisterStatus.innerHTML = vUser.registerStatus;

          // thêm data vào các dòng của button
          var vDetailButton = document.createElement("button"); //tạo element button
          vCellUserAction.appendChild(vDetailButton); // gắn nó vào ô
          vDetailButton.innerHTML = "Chi tiết"; //thêm label (nhãn của  button)
          vDetailButton.className = "btn btn-info info-user"; //kiểu button bootstrap và "info-user" là class để truy cập button sau này
          vDetailButton.setAttribute("data-id", vUser.id); //đặt thuộc tính (gán userID vào dataset của button)vDetailButton.setAttribute("data-firstname", vUser.firstname); // gán firstname vào dataset của button
          vDetailButton.setAttribute("data-firstname", vUser.firstname);
          vDetailButton.setAttribute("data-lastname", vUser.lastname);
          vDetailButton.setAttribute("data-country", vUser.country);
          vDetailButton.setAttribute("data-subject", vUser.subject);
          vDetailButton.setAttribute("onclick", "onBtnChiTietClick(this)");
        }
      }
    </script>
  </body>
</html>
